{% extends 'base.html' %}

{% block section %}
	<h1 class="mt-3 mb-5">{% block title %} {{ operation }} Schedule{% endblock %}</h1>
	<form action="{{ url_for('schedules.add') if 'Add' == operation else url_for('schedules.edit', schedule_name=schedule_form.schedule_name.data )}}" method="post">
		{{ schedule_form.csrf_token }}
		<div class="mx-auto w-50">
			{% if schedule_form.schedule_name.errors %}
				<div class="is-invalid">
					<div class="input-group">
						<span class="input-group-text"><strong>{{ schedule_form.schedule_name.label }}</strong></span>
						{{ schedule_form.schedule_name(class_="form-control is-invalid") }}
					</div>
					<ul class="errors list-group">
						{% for error in schedule_form.schedule_name.errors %}
							<li class="list-group-item form-check text-danger">{{ error }}</li>
						{% endfor %}
					</ul>
				</div>
			{% else %}
				<div class="input-group">
					<span class="input-group-text"><strong>{{ schedule_form.schedule_name.label }}</strong></span>
					{{ schedule_form.schedule_name(class_="form-control") }}
				</div>
			{% endif %}
		</div>
		<section class="schedule-add-recipes">
			{% for category in recipes %}
				<section class="recipe-category container">
					<h2 class="mb-5 mt-5">{{ category.title() }}</h2>
					{% for recipe in recipes[category] %}
						{% set recipe_id = (category.title() + recipe.title()).replace(" ", "") %}
						{{ recipes[category][recipe]["form"].recipe_name(type="hidden", readonly=True, value=recipe) }}
						{{ recipes[category][recipe]["form"].recipe_category(type="hidden", readonly=True, value=category) }}
						<section class="recipe row mb-5">
							<h3 class="fs-4 mb-3"><a href="{{ url_for('recipes.recipe', category=category, recipe_name=recipe.replace(" ", "-")) }}" class="link-primary link-offset-2 link-underline-opacity-25 link-underline-opacity-100-hover">{{ recipe }}</a></h3>
                            <div class="mb-3 row">
                                {% for specification in recipes[category][recipe]["specifications"] %}
                                    {% for size in recipes[category][recipe]["specifications"][specification] %}
                                        {% set recipe_spec_id = recipe_id + "-" + (specification.title() + size.title()).replace(" ", "") %}
                                        {% set spec_volume_id = "recipeSpecification-Volume-" + recipe_spec_id %}
                                        {% set spec_name_id = "recipeSpecification-Name-" + recipe_spec_id %}
                                        {% set spec_size_id = "recipeSpecification-Size-" + recipe_spec_id %}
                                        <div class="col">
                                            <div class="input-group">
                                                <span class="input-group-text"><strong>{{ size.title() }} {{ specification.title() }}</strong></span>
                                                <span class="input-group-text font-monospace text-end" id="specificationAmount-{{ recipe_spec_id }}">{{ recipes[category][recipe]["specifications"][specification][size]["amount"] }}</span>
                                                <span class="input-group-text" id="specificationUnit-{{ recipe_spec_id }}">{{ recipes[category][recipe]["specifications"][specification][size]["unit"] }}</span>
                                                {{ recipes[category][recipe]["specifications"][specification][size]["form"].specification_volume(class_="form-control recipe-specification font-monospace text-end", id=spec_volume_id) }}
                                            </div>
                                        </div>
                                        {{ recipes[category][recipe]["specifications"][specification][size]["form"].specification_name(id=spec_name_id, type="hidden", readonly=True, value=specification) }}
                                        {{ recipes[category][recipe]["specifications"][specification][size]["form"].specification_size(id=spec_size_id, type="hidden", readonly=True, value=size) }}
                                    {% endfor %}
                                {% endfor %}
                            </div>
                            <div class="mb-3 row">
                                <div class="col">
                                    <div class="input-group">
                                        <span class="input-group-text"><strong>Extra Yield</strong></span>
                                        {{ recipes[category][recipe]["form"].supplementary_yield(class_="form-control supplementary-yield font-monospace text-end", id=("recipeSpecification-supplementaryYield-" + recipe_id)) }}
                                        <span class="input-group-text">g</span>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group">
                                        <span class="input-group-text"><strong>Gross Yield</strong></span>
                                        {{ recipes[category][recipe]["form"].gross_yield(class_="form-control gross-yield font-monospace text-end", id=("grossYield-" + recipe_id), disabled=True, readonly=True) }}
                                        <span class="input-group-text">g</span>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group">
                                        <span class="input-group-text"><strong>Unit Cost</strong></span>
                                        <span class="input-group-text">$</span>
										<span style="background-color: var(--bs-secondary-bg)" class="form-control unit-cost font-monospace text-end" id="{{ ("unitCost-" + recipe_id) }}" readonly=True>{{ "{:.4f}".format(recipes[category][recipe]["unit_cost"]) }}</span>
                                        <span class="input-group-text">/ g</span>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group">
                                        <span class="input-group-text"><strong>Gross Cost</strong></span>
                                        <span class="input-group-text">$</span>
                                        {{ recipes[category][recipe]["form"].gross_cost(class_="form-control gross-cost font-monospace text-end", id=("grossCost-" + recipe_id), disabled=True, readonly=True) }}
                                    </div>
                                </div>
                            </div>
						</section>
					{% endfor %}
				</section>
			{% endfor %}
		</section>
		<button type="button" class="btn btn-secondary" onclick="javascript:history.back()">Cancel</button>
		<button type="submit" class="btn btn-primary">{{ "Add" if "Add" == operation else "Save" }}</button>
	</form>
	<script>
		function update_yield(event) {
				let gross_yield_value = 0
				let recipe_id = event.target.id.split("-")[2];
				let recipe_supplementary_yield = document.getElementById("recipeSpecification-supplementaryYield-" + recipe_id);
				let recipe_gross_yield = document.getElementById("grossYield-" + recipe_id);
				let recipe_unit_cost = document.getElementById("unitCost-" + recipe_id);
				let recipe_gross_cost = document.getElementById("grossCost-" + recipe_id);
				let product_specs = document.querySelectorAll(`[id^="recipeSpecification-Volume-${recipe_id}"]`);

				for (const product_spec of product_specs) {
					let spec_suffix = product_spec.id.split("-")[3];
					let spec_amount = document.getElementById("specificationAmount-" + recipe_id + "-" + spec_suffix).innerHTML;
					gross_yield_value += (parseInt(product_spec.value || 0) * parseInt(spec_amount))
				}
				gross_yield_value += parseInt(recipe_supplementary_yield.value || 0)
				recipe_gross_yield.value = gross_yield_value
				recipe_gross_cost.value = parseFloat(recipe_unit_cost.innerHTML * gross_yield_value).toPrecision(6)
		}
		const recipe_specifications = document.getElementsByClassName("recipe-specification");
		for (let recipe_specification of recipe_specifications) {
			recipe_specification.addEventListener("change", update_yield)
		}
		const supplementary_yields = document.getElementsByClassName("supplementary-yield");
		for (let supplementary_yield of supplementary_yields) {
			supplementary_yield.addEventListener("change", update_yield)
		}
	</script>
{% endblock %}
